if(isObject(ASE_ColorPickerGUI)) ASE_ColorPickerGUI.delete();
new GuiControl(ASE_ColorPickerGUI)
{
	new GuiWindowCtrl(ASE_ColorPickerUI)
	{
		position = "50 50";
		extent = "312 300";
		
		closeCommand = "Canvas.popDialog(ASE_ColorPickerGUI);";
		command = "Canvas.popDialog(ASE_ColorPickerGUI);";
		accelerator = "Escape";
		
		text = "Color Picker";
		
		resizeWidth = 0;
		resizeHeight = 0;
		
		canMinimize = 0;
		canMaximize = 0;
		
		new GuiBitmapCtrl(ASE_ColorTransUnderlay)
		{
			position = "10 32";
			extent = "64 64";
			
			bitmap = "Add-Ons/Client_AvatarSaver/Images/Swatch Trans Underlay";
		};
		
		new GuiBitmapCtrl(ASE_ColorArea)
		{
			position = "10 32";
			extent = "64 64";
			
			bitmap = "Add-Ons/Client_AvatarSaver/Images/Color Border";
			
			new GuiBitmapCtrl()
			{
				position = "0 0";
				extent = "64 64";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Border Edge";
			};
		};
		
		new GuiTextCtrl()
		{
			position = "10 275";
			extent = "20 20";
			
			text = "A:";
		};
		
		new GuiTextEditCtrl(ASE_AlphaTextbox)
		{
			position = "22 275";
			extent = "23 18";
			
			text = "255";
			lastValue = "255";
			
			maxLength = 6;
			command = "ASE_UpdateColorPicker();";
		};
		
		new GuiBitmapCtrl(ASE_AlphaTransUnderlay)
		{
			position = "49 276";
			extent = "256 16";
			
			bitmap = "Add-Ons/Client_AvatarSaver/Images/Slider Trans Underlay";
		};
		
		new GuiBitmapCtrl(ASE_AlphaSlider)
		{
			position = "49 276";
			extent = "256 16";
			
			bitmap = "Add-Ons/Client_AvatarSaver/Images/Alpha Slider";
		};
		
		new GuiMouseEventCtrl(ASE_AlphaSliderArea)
		{
			position = "49 276";
			extent = "256 16";
		};
		
		new GuiSwatchCtrl(ASE_RGBSwatch)
		{
			position = "10 172";
			extent = "295 100";
			
			color = "0 0 0 0";
			visible = 0;
			
			new GuiTextCtrl()
			{
				position = "0 37";
				extent = "20 20";
				
				text = "R:";
			};
			
			new GuiTextEditCtrl(ASE_RedTextbox)
			{
				position = "12 37";
				extent = "23 18";
				
				text = "255";
				lastValue = "255";
				
				maxLength = 6;
				command = "ASE_UpdateColorPicker();";
			};
			
			new GuiBitmapCtrl(ASE_RedTransUnderlay)
			{
				position = "39 38";
				extent = "256 16";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Slider Trans Underlay";
			};
			
			new GuiBitmapCtrl(ASE_RedSlider)
			{
				position = "39 38";
				extent = "256 16";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Red Slider";
			};
			
			new GuiMouseEventCtrl(ASE_RedSliderArea)
			{
				position = "39 38";
				extent = "256 16";
			};
			
			new GuiTextCtrl()
			{
				position = "0 59";
				extent = "20 20";
				
				text = "G:";
			};
			
			new GuiTextEditCtrl(ASE_GreenTextbox)
			{
				position = "12 59";
				extent = "23 18";
				
				text = "255";
				lastValue = "255";
				
				maxLength = 6;
				command = "ASE_UpdateColorPicker();";
			};
			
			new GuiBitmapCtrl(ASE_GreenTransUnderlay)
			{
				position = "39 60";
				extent = "256 16";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Slider Trans Underlay";
			};
			
			new GuiBitmapCtrl(ASE_GreenSlider)
			{
				position = "39 60";
				extent = "256 16";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Green Slider";
			};
			
			new GuiMouseEventCtrl(ASE_GreenSliderArea)
			{
				position = "39 60";
				extent = "256 16";
			};
			
			new GuiTextCtrl()
			{
				position = "0 81";
				extent = "20 20";
				
				text = "B:";
			};
			
			new GuiTextEditCtrl(ASE_BlueTextbox)
			{
				position = "12 81";
				extent = "23 18";
				
				text = "255";
				lastValue = "255";
				
				maxLength = 6;
				command = "ASE_UpdateColorPicker();";
			};
			
			new GuiBitmapCtrl(ASE_BlueTransUnderlay)
			{
				position = "39 82";
				extent = "256 16";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Slider Trans Underlay";
			};
			
			new GuiBitmapCtrl(ASE_BlueSlider)
			{
				position = "39 82";
				extent = "256 16";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Blue Slider";
			};
			
			new GuiMouseEventCtrl(ASE_BlueSliderArea)
			{
				position = "39 82";
				extent = "256 16";
			};
		};
		
		new GuiSwatchCtrl(ASE_HSVSwatch)
		{
			position = "10 172";
			extent = "294 100";
			
			color = "0 0 0 0";
			visible = 0;
			
			new GuiTextCtrl()
			{
				position = "0 37";
				extent = "20 20";
				
				text = "H:";
			};
			
			new GuiTextEditCtrl(ASE_HueTextbox)
			{
				position = "12 37";
				extent = "23 18";
				
				text = "0";
				lastValue = "0";
				
				maxLength = 6;
				command = "ASE_UpdateColorPicker();";
			};
			
			new GuiTextCtrl()
			{
				position = "0 59";
				extent = "20 20";
				
				text = "S:";
			};
			
			new GuiTextEditCtrl(ASE_SatTextbox)
			{
				position = "12 59";
				extent = "23 18";
				
				text = "0";
				lastValue = "0";
				
				maxLength = 6;
				command = "ASE_UpdateColorPicker();";
			};
			
			new GuiTextCtrl()
			{
				position = "0 81";
				extent = "20 20";
				
				text = "V:";
			};
			
			new GuiTextEditCtrl(ASE_ValTextbox)
			{
				position = "12 81";
				extent = "23 18";
				
				text = "100";
				lastValue = "100";
				
				maxLength = 6;
				command = "ASE_UpdateColorPicker();";
			};
			
			new GuiBitmapCtrl(ASE_HSVTransUnderlay)
			{
				position = "39 0";
				extent = "120 100";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/HSV Trans Underlay";
			};
			
			new GuiBitmapCtrl(ASE_HSVColorWheel)
			{
				position = "39 0";
				extent = "100 100";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Color Wheel";
				
				new GuiBitmapCtrl(ASE_HSVCrosshair)
				{
					position = "46 46";
					extent = "9 9";
					
					bitmap = "Add-Ons/Client_AvatarSaver/Images/Wheel Crosshair";
				};
				
				new GuiBitmapCtrl()   //Keeps the crosshair from exiting the wheel
				{
					position = "0 0";
					extent = "100 100";
					
					bitmap = "Add-Ons/Client_AvatarSaver/Images/Color Wheel Negative";
				};
			};
			
			new GuiMouseEventCtrl(ASE_HSVColorWheelArea)
			{
				position = "39 0";
				extent = "100 100";
			};
			
			new GuiBitmapCtrl(ASE_HSVColorSlider)
			{
				position = "143 0";
				extent = "16 100";
				
				bitmap = "Add-Ons/Client_AvatarSaver/Images/Small Vertical Slider";
			};
			
			new GuiMouseEventCtrl(ASE_HSVColorSliderArea)
			{
				position = "143 0";
				extent = "16 100";
			};
		};
		
		new GuiSwatchCtrl(ASE_ColorList)
		{
			position = "10 177";
			extent = "35 28";
			
			color = "0 0 0 0";
			
			new GuiSwatchCtrl()   //The radio buttons didn't like being so close together, so I have to use swatches to break them up
			{
				position = "0 0";
				extent = "35 12";
				
				color = "0 0 0 0";
				
				new GuiRadioCtrl(ASE_RGBButton)
				{
					position = "0 -9";
					text = "RGB";
										//vvv Unfortunately this makes them not work automatically as radio buttons.
					command = "ASE_HSVSwatch.setVisible(0); ASE_HSVButton.setValue(0);  ASE_RGBSwatch.setVisible(1); ASE_HSVCrosshair.setVisible(0);";
				};
			};
			
			new GuiSwatchCtrl()
			{
				position = "0 16";
				extent = "35 12";
				
				color = "0 0 0 0";
				
				new GuiRadioCtrl(ASE_HSVButton)
				{
					position = "0 -9";
					text = "HSV";
					
					command = "ASE_RGBSwatch.setVisible(0); ASE_RGBButton.setValue(0); ASE_HSVSwatch.setVisible(1); ASE_HSVCrosshair.setVisible(1);";
				};
			};
		};
		
		new GuiSwatchCtrl(ASE_HexColorer)
		{
			position = "173 173";
			extent = "132 33";
			
			color = "0 0 0 0";
			
			new GuiTextCtrl()
			{
				position = "39 0";
				extent = "20 20";
				
				text = "Hex:";
			};
			
			new GuiTextEditCtrl(ASE_HexTextbox)
			{
				position = "63 0";
				extent = "69 18";
				
				text = "FFFFFF";
				lastValue = "FFFFFF";
				
				maxLength = 16;
				command = "ASE_ValidateHexColor();";
				altCommand = "ASE_FromHexColor();";
			};
		};
		
		new GuiBitmapCtrl(ASE_ColorsetTransUnderlay)
		{
			position = "100 32";
			extent = "194 130";
			
			bitmap = "Add-Ons/Client_AvatarSaver/Images/Colorset Trans Underlay";
		};
		
		new GuiScrollCtrl(ASE_ColorsetScroll)
		{
			position = "100 32";
			extent = "205 130";
			
			profile = ColorScrollProfile;
			
			hScrollbar = "AlwaysOff";
			vScrollbar = "AlwaysOn";
			
			new GuiSwatchCtrl(ASE_ColorsetSwatch)
			{
				position = "0 0";
				extent = "194 130";
				
				color = "0 0 0 0";
			};
		};
		
		new GuiSwatchCtrl()
		{
			position = "101 32";
			extent = "192 1";
			minExtent = "192 1";
			
			color = "140 140 140";
		};
		
		new GuiSwatchCtrl()
		{
			position = "101 161";
			extent = "192 1";
			minExtent = "192 1";
			
			color = "140 140 140";
		};
	};
};
ASE_RGBButton.performClick();   //Make it remember which is clicked across client restarts

function ASE_ColorPickerGUI::onWake(%this)
{
	if($Avatar::NumColors $= "")
		exec("config/client/AvatarColors.cs");
	for(%i=ASE_ColorsetSwatch.getCount()-1;%i>=0;%i--)
		ASE_ColorsetSwatch.getObject(%i).delete();
	for(%i=0;%i<$Avatar::NumColors;%i++)
		ASE_AddColorToPicker($Avatar::Color[%i]);
}

function ASE_ColorPickerGUI::onSleep(%this)
{
	if(isObject(%btn = ASE_ColorArea.selectedColor))
	{
		%ind = %btn.indicator;
		cancel(%ind.flashSched);
		%ind.setVisible(0);
		ASE_ColorArea.selectedColor = "";
	}
}

function ASE_SelectColor(%btn)
{
	if(ASE_ColorArea.selectedColor == %btn)
	{
		%ind = %btn.indicator;
		cancel(%ind.flashSched);
		%ind.setVisible(0);
		ASE_ColorArea.selectedColor = "";
	}
	else
	{
		if(isObject(%obj = ASE_ColorArea.selectedColor))
		{
			%ind = %obj.indicator;
			cancel(%ind.flashSched);
			%ind.setVisible(0);
		}
		%col = %btn.getGroup().getColor();
		%red = mFloatLength(getWord(%col, 0) * 255, 0);
		%green = mFloatLength(getWord(%col, 1) * 255, 0);
		%blue = mFloatLength(getWord(%col, 2) * 255, 0);
		%alpha = mFloatLength(getWord(%col, 3) * 255, 0);
		ASE_AlphaTextbox.setValue(%alpha);
		ASE_RedTextbox.setValue(%red);
		ASE_GreenTextbox.setValue(%green);
		ASE_BlueTextbox.setValue(%blue);
		%hsv = RGBToHSV(%red / 255, %green / 255, %blue / 255);
		%hue = getWord(%hsv, 0); %sat = getWord(%hsv, 1); %val = getWord(%hsv, 2);
		if(%hue == -1) %hue = 0;
		ASE_HueTextbox.setValue(mFloatLength(%hue * 360, 0));
		ASE_SatTextbox.setValue(mFloatLength(%sat * 100, 0));
		ASE_ValTextbox.setValue(mFloatLength(%val * 100, 0));
		ASE_ColorArea.selectedColor = %btn;
		ASE_UpdateColorPicker();
		%ind = %btn.indicator;
		%ind.setVisible(1);
		ASE_FlashLoop(%ind);
	}
}

function ASE_FlashLoop(%ind)
{
	if(!isObject(%ind)) return;
	if((%len = vectorLen(%ind.getGroup().color)) <= 313 && !%ind.white) { %ind.setColor("1 1 1 1"); %ind.white = 1; }
	else if(%len > 313 && %ind.white) { %ind.setColor("0 0 0 1"); %ind.white = 0; }
	%time = $Sim::Time/2; %time -= mFloor(%time);
	%add = mSin(%time * 6.28318531);
	%alpha = 0.75 + %add / 4;
	%ind.setColor(getWords(%ind.getColor(), 0, 2) SPC %alpha);
	%ind.flashSched = schedule(16, 0, "ASE_FlashLoop", %ind);
}

function ASE_AddColorToPicker(%col)
{
	%r = mFloatLength(getWord(%col, 0) * 255, 0);
	%g = mFloatLength(getWord(%col, 1) * 255, 0);
	%b = mFloatLength(getWord(%col, 2) * 255, 0);
	if(getWordCount(%col) == 4)
		%a = mFloatLength(getWord(%col, 3) * 255, 0);
	%col = trim(%r SPC %g SPC %b SPC %a);
	%num = ASE_ColorsetSwatch.getCount();
	%y = mFloor(%num / 6);
	%x = %num - (%y * 6);
	
	if(%y*32+33 >= getWord(ASE_ColorsetSwatch.extent, 1))
		ASE_ColorsetSwatch.resize(0, 0, 194, %y*32+34);
	
	%swatch = new GuiSwatchCtrl()
	{
		position = %x*32+1 SPC %y*32+1;
		extent = "32 32";
		
		color = %col;
	};
	
	%swatch.add(%ind = new GuiBitmapCtrl()
	{
		position = "0 0";
		extent = "32 32";
		
		bitmap = "Add-Ons/Client_AvatarSaver/Images/Color Highlighter";
		text = "";
		
		visible = 0;
	});
	
	if(vectorLen(%col) <= 313) %ind.setColor("1 1 1 1");
	else %ind.setColor("0 0 0 1");
	
	%swatch.add(new GuiBitmapButtonCtrl()
	{
		position = "0 0";
		extent = "32 32";
		
		bitmap = "base/client/ui/btnColor";
		indicator = %ind;
		text = "";
		
		command = "ASE_SelectColor($ThisControl);";
	});
	
	ASE_ColorsetSwatch.add(%swatch);
}

//All of the textboxes need to work with copy-pasting.
function ASE_UpdateColorPicker()
{
	ASE_ValidateTextbox(ASE_AlphaTextbox, 255);
	ASE_ValidateTextbox(ASE_RedTextbox, 255);
	ASE_ValidateTextbox(ASE_GreenTextbox, 255);
	ASE_ValidateTextbox(ASE_BlueTextbox, 255);
	ASE_ValidateTextbox(ASE_HueTextbox, 360);
	ASE_ValidateTextbox(ASE_SatTextbox, 100);
	ASE_ValidateTextbox(ASE_ValTextbox, 100);
	%alpha = ASE_AlphaTextbox.getValue() / 255;
	if(ASE_RGBSwatch.isVisible())
	{
		%col = ASE_RedTextbox.getValue() / 255 SPC ASE_GreenTextbox.getValue() / 255 SPC ASE_BlueTextbox.getValue() / 255;
		%hsv = RGBToHSV(getWord(%col, 0), getWord(%col, 1), getWord(%col, 2));
		%hue = getWord(%hsv, 0); %sat = getWord(%hsv, 1); %val = getWord(%hsv, 2);
		if(%hue == -1) %hue = 0;
		ASE_HueTextbox.setValue(mFloatLength(%hue * 360, 0));
		ASE_SatTextbox.setValue(mFloatLength(%sat * 100, 0));
		ASE_ValTextbox.setValue(mFloatLength(%val * 100, 0));
	}
	else
	{
		%col = HSVToRGB(ASE_HueTextbox.getValue() / 360, ASE_SatTextbox.getValue() / 100, ASE_ValTextbox.getValue() / 100);
		%col = mFloatLength(getWord(%col,0)*255,0)/255 SPC mFloatLength(getWord(%col,1)*255,0)/255 SPC mFloatLength(getWord(%col,2)*255,0)/255;
		%hue = ASE_HueTextbox.getValue() / 360; %sat = ASE_SatTextbox.getValue() / 100; %val = ASE_ValTextbox.getValue() / 100;
		ASE_RedTextbox.setValue(mFloatLength(getWord(%col, 0) * 255, 0));
		ASE_GreenTextbox.setValue(mFloatLength(getWord(%col, 1) * 255, 0));
		ASE_BlueTextbox.setValue(mFloatLength(getWord(%col, 2) * 255, 0));
	}
	ASE_ColorArea.setColor(%col SPC %alpha);
	if(isObject(%btn = ASE_ColorArea.selectedColor))
		%btn.getGroup().setColor(%col SPC %alpha);
	ASE_RedSlider.setColor("1 "@getWords(%col, 1, 2) SPC %alpha);
	ASE_GreenSlider.setColor(getWord(%col, 0)@" 1 "@getWord(%col, 2) SPC %alpha);
	ASE_BlueSlider.setColor(getWords(%col, 0, 1)@" 1 "@%alpha);
	ASE_HSVColorWheel.setColor(%val SPC %val SPC %val SPC %alpha);
	ASE_HSVColorSlider.setColor(HSVToRGB(%hue, %sat, 1) SPC %alpha);
	%x = mSin(%hue * 6.28319); %y = -mCos(%hue * 6.28319);
	ASE_HSVCrosshair.resize(mFloatLength(45.5 + %x * (%sat * 50), 0), mFloatLength(45.5 + %y * (%sat * 50), 0), 9, 9);
	ASE_AlphaSlider.setColor(%col@" 1");
	ASE_ToHexColor();
}

function ASE_ValidateTextbox(%box, %max)
{
	%pos = %box.getCursorPos();
	%val = %box.getValue();
	if(strLen(%val) > 4) %val = getSubStr(%val, 0, 4);
	for(%i=0;%i<strLen(%val);%i++)
		if(strPos("1234567890", getSubStr(%val, %i, 1)) == -1)
			%badValue = 1;
	if(%badValue) { %box.setValue(%box.lastValue); %box.setCursorPos(%pos - 1); }
	else %box.setValue(getMin(%val, %max));
	%box.lastValue = %box.getValue();
}

function ASE_ToHexColor()
{
	%base = "0123456789ABCDEF";
	%red = ASE_RedTextbox.getValue();
	%green = ASE_GreenTextbox.getValue();
	%blue = ASE_BlueTextbox.getValue();
	%alpha = ASE_AlphaTextbox.getValue();
	%rVal = getSubStr(%base, %v = mFloor(%red / 16), 1) @ getSubStr(%base, %red - (%v * 16), 1);
	%gVal = getSubStr(%base, %v = mFloor(%green / 16), 1) @ getSubStr(%base, %green - (%v * 16), 1);
	%bVal = getSubStr(%base, %v = mFloor(%blue / 16), 1) @ getSubStr(%base, %blue - (%v * 16), 1);
	%aVal = getSubStr(%base, %v = mFloor(%alpha / 16), 1) @ getSubStr(%base, %alpha - (%v * 16), 1);
	%hex = %rVal@%gVal@%bVal@(%alpha==255?"":%aVal);
	ASE_HexTextbox.setValue(%hex);
}

function ASE_FromHexColor()
{
	%box = ASE_HexTextbox;
	ASE_ValidateHexColor();
	%hex = strUpr(%box.getValue());
	if(strLen(%hex) != 6 && strLen(%hex) != 8) return;
	%base = "0123456789ABCDEF";
	%red = strPos(%base, getSubStr(%hex, 0, 1)) * 16 + strPos(%base, getSubStr(%hex, 1, 1));
	%green = strPos(%base, getSubStr(%hex, 2, 1)) * 16 + strPos(%base, getSubStr(%hex, 3, 1));
	%blue = strPos(%base, getSubStr(%hex, 4, 1)) * 16 + strPos(%base, getSubStr(%hex, 5, 1));
	if(strLen(%hex) != 8) %alpha = 255;
	else %alpha = strPos(%base, getSubStr(%hex, 6, 1)) * 16 + strPos(%base, getSubStr(%hex, 7, 1));
	ASE_AlphaTextbox.setValue(%alpha);
	ASE_RedTextbox.setValue(%red);
	ASE_GreenTextbox.setValue(%green);
	ASE_BlueTextbox.setValue(%blue);
	%hsv = RGBToHSV(%red / 255, %green / 255, %blue / 255);
	%hue = getWord(%hsv, 0); %sat = getWord(%hsv, 1); %val = getWord(%hsv, 2);
	if(%hue == -1) %hue = 0;
	ASE_HueTextbox.setValue(mFloatLength(%hue * 360, 0));
	ASE_SatTextbox.setValue(mFloatLength(%sat * 100, 0));
	ASE_ValTextbox.setValue(mFloatLength(%val * 100, 0));
	ASE_UpdateColorPicker();
}

function ASE_ValidateHexColor()
{
	%box = ASE_HexTextbox;
	%pos = %box.getCursorPos();
	%hex = strUpr(%box.getValue());
	if(strLen(%hex) > 8)
	{ %box.setValue(%box.lastValue); return; }
	for(%i=0;%i<strLen(%hex);%i++)
		if(strPos("1234567890ABCDEF", getSubStr(%hex, %i, 1)) == -1)
			%badValue = 1;
	if(%badValue) { %box.setValue(%box.lastValue); %box.setCursorPos(%pos - 1); }
	else { %box.setValue(%hex); %box.setCursorPos(%pos); }
	%box.lastValue = %box.getValue();
}

function ASE_AlphaSliderArea::onMouseDown(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%alpha = getWord(%hit, 0);
	ASE_AlphaTextbox.setValue(%alpha);
	ASE_UpdateColorPicker();
}

function ASE_AlphaSliderArea::onMouseDragged(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%alpha = getWord(%hit, 0);
	ASE_AlphaTextbox.setValue(%alpha);
	ASE_UpdateColorPicker();
}

function ASE_RedSliderArea::onMouseDown(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%red = getWord(%hit, 0) - 10;
	ASE_RedTextbox.setValue(%red);
	ASE_UpdateColorPicker();
}

function ASE_RedSliderArea::onMouseDragged(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%red = getWord(%hit, 0) - 10;
	ASE_RedTextbox.setValue(%red);
	ASE_UpdateColorPicker();
}

function ASE_GreenSliderArea::onMouseDown(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%green = getWord(%hit, 0) - 10;
	ASE_GreenTextbox.setValue(%green);
	ASE_UpdateColorPicker();
}

function ASE_GreenSliderArea::onMouseDragged(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%green = getWord(%hit, 0) - 10;
	ASE_GreenTextbox.setValue(%green);
	ASE_UpdateColorPicker();
}

function ASE_BlueSliderArea::onMouseDown(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%blue = getWord(%hit, 0) - 10;
	ASE_BlueTextbox.setValue(%blue);
	ASE_UpdateColorPicker();
}

function ASE_BlueSliderArea::onMouseDragged(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(ASE_ColorPickerUI.position, %this.position));
	%blue = getWord(%hit, 0) - 10;
	ASE_BlueTextbox.setValue(%blue);
	ASE_UpdateColorPicker();
}

function ASE_HSVColorWheelArea::onMouseDown(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(vectorAdd(ASE_ColorPickerUI.position, %this.position), "59.5 221.5"));
	if(vectorLen(%hit) > 50) return;
	%hue = mAtan(getWord(%hit, 0), -getWord(%hit, 1)) / 6.28319;
	if(%hue < 0) %hue++; %sat = vectorLen(%hit) / 50;
	ASE_HueTextbox.setValue(mFloatLength(%hue * 360, 0)); ASE_SatTextbox.setValue(mFloatLength(%sat * 100, 0));
	ASE_UpdateColorPicker();
}

function ASE_HSVColorWheelArea::onMouseDragged(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(vectorAdd(ASE_ColorPickerUI.position, %this.position), "59.5 221.5"));
	if(vectorLen(%hit) > 50) return;
	%hue = mAtan(getWord(%hit, 0), -getWord(%hit, 1)) / 6.28319;
	if(%hue < 0) %hue++; %sat = vectorLen(%hit) / 50;
	ASE_HueTextbox.setValue(mFloatLength(%hue * 360, 0)); ASE_SatTextbox.setValue(mFloatLength(%sat * 100, 0));
	ASE_UpdateColorPicker();
}

function ASE_HSVColorSliderArea::onMouseDown(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(vectorAdd(ASE_ColorPickerUI.position, %this.position), "10 172"));
	%val = (99 - getWord(%hit, 1)) / 99; ASE_ColorPickerUI.lastVal = %val;
	ASE_ValTextbox.setValue(mFloatLength(%val * 100, 0));
	ASE_UpdateColorPicker();
}

function ASE_HSVColorSliderArea::onMouseDragged(%this, %mod, %pos, %clicks)
{
	%hit = vectorSub(%pos, vectorAdd(vectorAdd(ASE_ColorPickerUI.position, %this.position), "10 172"));
	%val = (99 - getWord(%hit, 1)) / 99; ASE_ColorPickerUI.lastVal = %val;
	ASE_ValTextbox.setValue(mFloatLength(%val * 100, 0));
	ASE_UpdateColorPicker();
}